<!DOCTYPE html>
<html lang="en">
<head>
  <title>List users</title>
  <meta charset="utf-8" />
  <meta name="viewport" content="width=device-width, initial-scale=1" />
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css" />
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

  <!-- Import DataTable and its Bootstrap style -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css" />
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>
<body>
  <div class="container">
    <div class="text-center mt-4 mb-3">
      <h2>Danh sách người dùng</h2>
    </div>

    <table id="user-table" class="table table-bordered table-striped table-hover">
      <thead>
        <tr>
          <th>STT</th>
          <th>Username</th>
          <th>First name</th>
          <th>Last name</th>
          <th>Email</th>
          <th>Age</th>
          <th>Role</th>
          <th>Action</th>
        </tr>
      </thead>
      <tbody></tbody>
    </table>
  </div>
  
  <script>
    $(document).ready(function () {
      var gJsonUser = `{
        "description": "Data user",
        "users": [
          {
            "id": 2,
            "username": "quannv",
            "firstname": "Ngo Van",
            "lastname": "Quan",
            "age": 18,
            "email": "quan@gmail.com",
            "roleId": 5
          },
          {
            "id": 3,
            "username": "longdh",
            "firstname": "Do Hoang",
            "lastname": "Long",
            "age": 19,
            "email": "long@gmail.com",
            "roleId": 8
          },
          {
            "id": 4,
            "username": "hiendt",
            "firstname": "Do Thi",
            "lastname": "Hien",
            "age": 29,
            "email": "hien@gmail.com",
            "roleId": 11
          },
          {
            "id": 6,
            "username": "lanht",
            "firstname": "Ho Thi",
            "lastname": "Lan",
            "age": 27,
            "email": "lan@gmail.com",
            "roleId": 13
          }
        ]
      }`;
      var gJsonRole = `{
        "description": "User Roles",
        "roles": [
          {
            "roleId": 5,
            "roleName": "Admin"
          },
          {
            "roleId": 8,
            "roleName": "Manager"
          },
          {
            "roleId": 11,
            "roleName": "Teacher"
          },
          {
            "roleId": 13,
            "roleName": "Staff"
          }
        ]
      }`;
      
      var gObjectJsonUser = JSON.parse(gJsonUser);
      var gObjectJsonRole = JSON.parse(gJsonRole);
      var gUserName = [
        "id",
        "username",
        "firstname",
        "lastname",
        "email",
        "age",
        "roleId",
        "action",
      ];

      const gSTT_COL = 0;
      const gUSERNAME_COL = 1;
      const gFIRSTNAME_COL = 2;
      const gLASTNAME_COL = 3;
      const gEMAIL_COL = 4;
      const gAGE_COL = 5;
      const gROLE_COL = 6;
      const gACTION_COL = 7;
      var gStt = 0;
      onPageLoading();

      function onPageLoading() {
        $("#user-table").DataTable({
          columns: [
            { data: gUserName[gSTT_COL] },
            { data: gUserName[gUSERNAME_COL] },
            { data: gUserName[gFIRSTNAME_COL] },
            { data: gUserName[gLASTNAME_COL] },
            { data: gUserName[gEMAIL_COL] },
            { data: gUserName[gAGE_COL] },
            { data: gUserName[gROLE_COL] },
            { data: gUserName[gACTION_COL] },
          ],
          columnDefs: [
            {
              targets: gSTT_COL,
              className: "text-primary",
              render: function () {
                gStt++;
                return gStt;
              },
            },
            {
              targets: gROLE_COL,
              className: "text-primary",
              render: function (data) {
                var roleName = "CHUA_CO_TEN";
                var found = false;
                var i = 0;
                while (!found && i < gObjectJsonRole.roles.length) {
                  if (gObjectJsonRole.roles[i].roleId === data) {
                    roleName = gObjectJsonRole.roles[i].roleName;
                    found = true;
                  }
                  i++;
                }
                return roleName;
              },
            },
            {
              targets: gACTION_COL,
              defaultContent:
                '<button class="btn btn-primary btn-detail">chi tiết</button>',
            },
          ],
        });
      }

      function loadDataToTable(paramObjectJsonUser) {
        var vTable = $("#user-table").DataTable();
        vTable.clear().rows.add(paramObjectJsonUser.users).draw();
      }

      $(document).on("click", ".btn-detail", function () {
        var vRowSelected = $(this).closest("tr");
        var vTable = $("#user-table").DataTable();
        var vDataRow = vTable.row(vRowSelected).data();

        console.log("Username: " + vDataRow.username);
        console.log("First name: " + vDataRow.firstname);
        console.log("Last name: " + vDataRow.lastname);
        console.log("Email: " + vDataRow.email);
        console.log("Age: " + vDataRow.age);
        console.log("Role ID: " + vDataRow.roleId);
      });

      loadDataToTable(gObjectJsonUser);
    });
  </script>
</body>
</html>
